Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs	(revision 14446)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs	(revision 14459)
@@ -35,16 +35,13 @@
     private const int MAX_DISTINCT_VALUES_FOR_CLASSIFCATION = 20;
 
-    private int classifierVariableIndex = 0;
+    public int ClassifierVariableIndex { get; set; }
 
-    public int ClassifierVariableIndex {
-      get { return this.classifierVariableIndex; }
-      set { this.classifierVariableIndex = value; }
-    }
-    public bool IsDetailedChartViewEnabled { get; set; }
-
+    public int Bins { get; set; }
+    public bool ExactBins { get; set; }
 
     public HistogramContent(IFilteredPreprocessingData preprocessingData)
       : base(preprocessingData) {
-      AllInOneMode = false;
+      Bins = 10;
+      ExactBins = false;
     }
 
@@ -70,5 +67,4 @@
       return doubleVariableNames;
     }
-
   }
 }
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs	(revision 14446)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/LineChartContent.cs	(revision 14459)
@@ -29,4 +29,10 @@
   public class LineChartContent : PreprocessingChartContent {
 
+    private bool allInOneMode = true;
+    public bool AllInOneMode {
+      get { return this.allInOneMode; }
+      set { this.allInOneMode = value; }
+    }
+
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Performance; }
@@ -39,4 +45,5 @@
     public LineChartContent(LineChartContent content, Cloner cloner)
       : base(content, cloner) {
+      this.allInOneMode = content.allInOneMode;
     }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 14446)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 14459)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 using System.Drawing;
@@ -33,10 +32,4 @@
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.PieChart; }
-    }
-
-    private bool allInOneMode = true;
-    public bool AllInOneMode {
-      get { return this.allInOneMode; }
-      set { this.allInOneMode = value; }
     }
 
@@ -55,5 +48,4 @@
     public PreprocessingChartContent(PreprocessingChartContent content, Cloner cloner)
       : base(content, cloner) {
-      this.allInOneMode = content.allInOneMode;
       this.PreprocessingData = content.PreprocessingData;
       this.variableItemList = cloner.Clone<ICheckedItemList<StringValue>>(variableItemList);
@@ -62,5 +54,4 @@
       return new PreprocessingChartContent(this, cloner);
     }
-
 
     public DataRow CreateDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType) {
@@ -71,56 +62,5 @@
     }
 
-    public List<DataRow> CreateAllDataRows(DataRowVisualProperties.DataRowChartType chartType) {
-      List<DataRow> dataRows = new List<DataRow>();
-      foreach (var name in PreprocessingData.GetDoubleVariableNames())
-        dataRows.Add(CreateDataRow(name, chartType));
-      return dataRows;
-    }
 
-    public DataRow CreateSelectedDataRow(string variableName, DataRowVisualProperties.DataRowChartType chartType) {
-
-      IDictionary<int, IList<int>> selection = PreprocessingData.Selection;
-      int variableIndex = PreprocessingData.GetColumnIndex(variableName);
-
-      if (selection.Keys.Contains(variableIndex)) {
-        List<int> selectedIndices = new List<int>(selection[variableIndex]);
-        //need selection with more than 1 value
-        if (selectedIndices.Count < 2)
-          return null;
-
-        selectedIndices.Sort();
-        int start = selectedIndices[0];
-        int end = selectedIndices[selectedIndices.Count - 1];
-
-        DataRow rowSelect = CreateDataRowRange(variableName, start, end, chartType);
-        return rowSelect;
-      } else
-        return null;
-    }
-
-    public DataRow CreateDataRowRange(string variableName, int start, int end, DataRowVisualProperties.DataRowChartType chartType) {
-      IList<double> values = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableName));
-      IList<double> valuesRange = new List<double>();
-      for (int i = 0; i < values.Count; i++) {
-        if (i >= start && i <= end)
-          valuesRange.Add(values[i]);
-        else
-          valuesRange.Add(Double.NaN);
-      }
-
-      DataRow row = new DataRow(variableName, "", valuesRange);
-      row.VisualProperties.ChartType = chartType;
-      return row;
-    }
-
-    public List<DataRow> CreateAllSelectedDataRows(DataRowVisualProperties.DataRowChartType chartType) {
-      List<DataRow> dataRows = new List<DataRow>();
-      foreach (var name in PreprocessingData.GetDoubleVariableNames()) {
-        DataRow row = CreateSelectedDataRow(name, chartType);
-        if (row != null)
-          dataRows.Add(row);
-      }
-      return dataRows;
-    }
 
 
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingDataTable.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingDataTable.cs	(revision 14446)
+++ 	(revision )
@@ -1,58 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Analysis;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.DataPreprocessing {
-  [Item("PreprossingDataTable", "A table of data values.")]
-  public class PreprocessingDataTable : DataTable {
-
-    public PreprocessingDataTable()
-      : base() {
-      SelectedRows = new NamedItemCollection<DataRow>();
-    }
-    public PreprocessingDataTable(string name)
-      : base(name) {
-      SelectedRows = new NamedItemCollection<DataRow>();
-    }
-
-    protected PreprocessingDataTable(PreprocessingDataTable original, Cloner cloner)
-      : base(original, cloner) {
-      this.selectedRows = cloner.Clone(original.selectedRows);
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PreprocessingDataTable(this, cloner);
-    }
-
-    private NamedItemCollection<DataRow> selectedRows;
-    public NamedItemCollection<DataRow> SelectedRows {
-      get { return selectedRows; }
-      private set {
-        if (selectedRows != null) throw new InvalidOperationException("Rows already set");
-        selectedRows = value;
-      }
-    }
-
-  }
-}
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/HeuristicLab.DataPreprocessing-3.4.csproj
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/HeuristicLab.DataPreprocessing-3.4.csproj	(revision 14446)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/HeuristicLab.DataPreprocessing-3.4.csproj	(revision 14459)
@@ -126,5 +126,4 @@
     <Compile Include="Content\PreprocessingChartContent.cs" />
     <Compile Include="Data\PreprocessingData.cs" />
-    <Compile Include="Content\PreprocessingDataTable.cs" />
     <Compile Include="Content\IViewChartShortcut.cs" />
     <Compile Include="Data\IFilteredPreprocessingData.cs" />